<!DOCTYPE html>
<html lang="de">
	<head>
		<meta charset="utf-8" />
		<title>WED1 - CSS Übung: Vererbung und Kaskadierung</title>
		<link rel="stylesheet" href="styles/default.css"/>
		<link rel="icon" href="../HSR.Template.Exercises/icon-document.png" type="image/png">
		<link rel="stylesheet" type="text/css" href="../HSR.Template.Exercises/documentStyle.css">
		<link rel="stylesheet" type="text/css" href="styles/styles.css">

		<script src="../HSR.Template.Exercises/solutions.js"></script>
		<script src="https://cdn.rawgit.com/google/code-prettify/master/loader/run_prettify.js"></script>
		<style>
			.solutionBox { width: 100%; height: 5em; }
			.marked { background: lightgreen; }


		</style>
	</head>
	<body>
		<h1>
			<a class="backlink" href="../index.html">⇦</a>
			WED1 - CSS Vererbung und Kaskadierung
			<button id="showSolutions">Lösungen anzeigen/ausblenden</button>
		</h1>

		<h2>Theorie</h2>
		<p>Lesen Sie die Artikel <a href="http://wiki.selfhtml.org/wiki/CSS/Vererbung" target="_blank">http://wiki.selfhtml.org/wiki/CSS/Vererbung</a> und
			<a href="http://wiki.selfhtml.org/wiki/CSS/Kaskade" target="_blank">http://wiki.selfhtml.org/wiki/CSS/Kaskade</a>
			um Vererbung, Kaskadierung und Spezifität von Regeln zu verstehen.
		</p>


		<h2>Aufgabenbeschreibung</h2>
		<p class="description">Sehen Sie sich die Darstellung im Abschnitt <a href="#chapter:vorlage">Vorlage</a> an. (ganz unten)
			Untersuchen Sie mittels Entwicklertools die definierten Styles und beantworten Sie die Fragen.
			Lösen Sie anschliessend die Aufgaben.</p>


		<h2>Fragen</h2>
		<ol>
			<li>Warum werden die Unterpunkte der Liste ebenfalls blau eingefärbt, obwohl explizit nur die Oberpunkte eingefärbt werden?
				<div class="solution">
					<p>Die Eigenschaft &quot;color&quot; vererbt standartmässig ihren Wert auf Kindelemente.
						Darum führt eine Definition der Farbe für das Elternelement dazu, das auch die alle Unterpunkte blau eingefärbt werden.
				<pre class="prettyprint"><code class="language-css"><!--
				-->body > ul > li {
	color: rgb(0, 96, 160);
}<!--
				--></code></pre></div>

			</li>
			<li>Welche der folgenden CSS Eigenschaften werden an Kindelemente vererbt, und welche Eigenschaften nicht?
				<form>
					<table>
						<thead>
						<tr>
							<th></th>
							<th>wird vererbt</th>
							<th>Wird nicht vererbt</th>
						</tr>
						</thead>
						<tbody>
						<tr>
							<th>border</th>
							<td><input type="radio" name="border" /></td>
							<td><input type="radio" name="border" /></td>
						</tr>
						<tr>
							<th>margin</th>
							<td><input type="radio" name="margin" /></td>
							<td><input type="radio" name="margin" /></td>
						</tr>
						<tr>
							<th>padding</th>
							<td><input type="radio" name="padding" /></td>
							<td><input type="radio" name="padding" /></td>
						</tr>
						<tr>
							<th>color</th>
							<td><input type="radio" name="color" /></td>
							<td><input type="radio" name="color" /></td>
						</tr>
						<tr>
							<th>background</th>
							<td><input type="radio" name="background" /></td>
							<td><input type="radio" name="background" /></td>
						</tr>
						<tr>
							<th>font</th>
							<td><input type="radio" name="font" /></td>
							<td><input type="radio" name="font" /></td>
						</tr>
						<tr>
							<th>text-decoration</th>
							<td><input type="radio" name="text-decoration" /></td>
							<td><input type="radio" name="text-decoration" /></td>
						</tr>
						</tbody>
					</table>

					<table>
						<thead>
						<tr>
							<th></th>
							<th>wird vererbt</th>
							<th>Wird nicht vererbt</th>
						</tr>
						</thead>
						<tbody>
						<tr>
							<th>text-indent</th>
							<td><input type="radio" name="text-indent" /></td>
							<td><input type="radio" name="text-indent" /></td>
						</tr>
						<tr>
							<th>text-align</th>
							<td><input type="radio" name="text-align" /></td>
							<td><input type="radio" name="text-align" /></td>
						</tr>
						<tr>
							<th>cursor</th>
							<td><input type="radio" name="cursor" /></td>
							<td><input type="radio" name="cursor" /></td>
						</tr>
						<tr>
							<th>content</th>
							<td><input type="radio" name="content" /></td>
							<td><input type="radio" name="content" /></td>
						</tr>
						<tr>
							<th>list-style-*</th>
							<td><input type="radio" name="list-style" /></td>
							<td><input type="radio" name="list-style" /></td>
						</tr>
						<tr>
							<th>display</th>
							<td><input type="radio" name="display" /></td>
							<td><input type="radio" name="display" /></td>
						</tr>
						<tr>
							<th>position</th>
							<td><input type="radio" name="position" /></td>
							<td><input type="radio" name="position" /></td>
						</tr>
						</tbody>
					</table>
				</form>
				<div class="solution">
					<p>
						Siehe <a href="http://www.thestyleworks.de/basics/inheritance.shtml">http://www.thestyleworks.de/basics/inheritance.shtml</a>
					</p>
					<form>
						<table>
							<thead>
							<tr>
								<th></th>
								<th>wird vererbt</th>
								<th>Wird nicht vererbt</th>
							</tr>
							</thead>
							<tbody>
							<tr>
								<th>border</th>
								<td><input type="radio" name="border" /></td>
								<td><input type="radio" name="border" checked="checked" /></td>
							</tr>
							<tr>
								<th>margin</th>
								<td><input type="radio" name="margin" /></td>
								<td><input type="radio" name="margin" checked="checked" /></td>
							</tr>
							<tr>
								<th>padding</th>
								<td><input type="radio" name="padding" /></td>
								<td><input type="radio" name="padding" checked="checked" /></td>
							</tr>
							<tr>
								<th>color</th>
								<td><input type="radio" name="color" checked="checked" /></td>
								<td><input type="radio" name="color" /></td>
							</tr>
							<tr>
								<th>background</th>
								<td><input type="radio" name="background"/></td>
								<td><input type="radio" name="background" checked="checked"/></td>
							</tr>
							<tr>
								<th>font</th>
								<td><input type="radio" name="font" checked="checked" /></td>
								<td><input type="radio" name="font" /></td>
							</tr>
							<tr>
								<th>text-decoration</th>
								<td><input type="radio" name="text-decoration" /></td>
								<td><input type="radio" name="text-decoration" checked="checked" /></td>
							</tr>
							</tbody>
						</table>

						<table>
							<thead>
							<tr>
								<th></th>
								<th>wird vererbt</th>
								<th>Wird nicht vererbt</th>
							</tr>
							</thead>
							<tbody>
							<tr>
								<th>text-indent</th>
								<td><input type="radio" name="text-indent" checked="checked" /></td>
								<td><input type="radio" name="text-indent" /></td>
							</tr>
							<tr>
								<th>text-align</th>
								<td><input type="radio" name="text-align" checked="checked" /></td>
								<td><input type="radio" name="text-align" /></td>
							</tr>
							<tr>
								<th>cursor</th>
								<td><input type="radio" name="cursor" checked="checked" /></td>
								<td><input type="radio" name="cursor" /></td>
							</tr>
							<tr>
								<th>content</th>
								<td><input type="radio" name="content" /></td>
								<td><input type="radio" name="content" checked="checked" /></td>
							</tr>
							<tr>
								<th>list-style-*</th>
								<td><input type="radio" name="list-style" checked="checked" /></td>
								<td><input type="radio" name="list-style" /></td>
							</tr>
							<tr>
								<th>display</th>
								<td><input type="radio" name="display" /></td>
								<td><input type="radio" name="display" checked="checked" /></td>
							</tr>
							<tr>
								<th>position</th>
								<td><input type="radio" name="position" /></td>
								<td><input type="radio" name="position" checked="checked" /></td>
							</tr>
							</tbody>
						</table>
					</form>
				</div>

			</li>

			<li>Erklären Sie, warum der Listenpunkt &quot;Hauptsitz&quot; fett dargestellt wird. Berechnen Sie die dazu die Spezifität des Inline-Styles und des im Stylesheet definierten Styles.
				<div class="solution">
					<p>Siehe
						<a href="http://wiki.selfhtml.org/wiki/CSS/Kaskade#Spezifit.C3.A4t_der_Regels.C3.A4tze" target="_blank">Spezifität</a>
					</p>
					<ul>
						<li>Spezifität der Regel des Inline Styles (element { font-weight: bold; })<br />
							<ul>
								<li>S:1 (Style-Attribut)
								<li>A:0 (ID-Selektoren)</li>
								<li>B:0 (Attribut-, Klassen- und Pseudoselektoren)</li>
								<li>C:0 (Typ- oder Pseudoelementselektoren)</li>
							</ul>
							<strong>Total: 1 0 0 0</strong>
						</li>
						<li>Spezifität der Regel im Stylesheet (li > ul { font-weight: normal; })<br />
							<ul>
								<li>S:0 (Style-Attribut)
								<li>A:0 (ID-Selektoren)</li>
								<li>B:0 (Attribut-, Klassen- und Pseudoselektoren)</li>
								<li>C:2 (Typ- oder Pseudoelementselektoren)</li>
							</ul>
							<strong>Total: 0 0 0 2</strong>
						</li>
					</ul>
					<p>Da die Spezifität der Regel im Inline Style höher ist als die Spezifität der Regel aus dem Stylesheet, wird das Element fett dargestellt.</p>
				</div>
			</li>
		</ol>


		<h2>Aufgaben</h2>
		<ol>
			<li>Färben Sie alle Unterpunkte in der Vorlage mit nur einer Regel schwarz ein.</li>
			<div class="solution">
                <pre class="prettyprint"><code class="language-css"><!--
-->ul > li > ul {
	color: black;
}<!--
                --></code></pre>
			</div>
			<li>Die Unterpunkte sollen ebenfalls quadratische Aufzählungspunkte verwenden.
				Definieren Sie eine entsprechende Regel für <pre><code>li > ul</code></pre>ohne das Wort &quot;square&quot; zu verwenden.</li>
			<div class="solution">
				<p>&quot;inherit&quot; erlaubt es, den Aufzählungspunkttyp vom Elternelement zu erben:</p>
				<pre class="prettyprint"><code class="language-css"><!--
-->li > ul {
	list-style-type:inherit;
}<!--
				--></code></pre>
			</div>
			<li>Binden Sie ein zusätzliches Stylesheet <strong>VOR</strong> dem Stylesheet <a href="style.css" target="_blank">style.css</a> ein,
				in welchem Sie eine Regel definieren, die die Unterpunkte ebenfalls fett formatiert und die definierte Regel im &quot;default.css&quot; überlagert. Verwenden Sie dazu <strong>NICHT</strong> &quot;!important&quot; und nicht &quot;bold&quot;.
				<div class="solution">
					<p>Um die bestehende Regel zu überschreiben, muss eine Regel mit grösserer Spezifität erstellt werden:</p>
				<pre class="prettyprint"><code class="language-html"><!--
				-->&lt;link rel=&quot;stylesheet&quot; type=&quot;text/css&quot; href=&quot;myStyle.css&quot;&gt;<!--
				--></code></pre>
					<p>myStyle.css:</p>
				<pre class="prettyprint"><code class="language-css"><!--
-->body > ul > li ul {
	font-weight: inherit;
}<!--
				--></code></pre>
				</div>

			</li>
		</ol>

		<h2 id="chapter:vorlage">Vorlage</h2>
		<ul>
			<li>Standort Zürich
				<ul>
					<li>Zürich Central
						<ul>
							<li>Filiale Bahnhofstrasse</li>
							<li>Filiale Museeumsstrasse</li>
						</ul>
					</li>
					<li style="font-weight: bold;">Hauptsitz</li>
				</ul>
			</li>
			<li>Filiale Genf</li>
			<li>Standort Bern
				<ul>
					<li>Filiale Nord</li>
					<li>Filiale West</li>
				</ul>
			</li>
			<li>Filiale Lugano</li>
		</ul>

	</body>
</html>
